/*
Copyright (c) 2005 Sean Billig

Permission is hereby granted, free of charge, to any person obtaining a copy of this software and associated documentation files (the "Software"), to deal in the Software without restriction, including without limitation the rights to use, copy, modify, merge, publish, distribute, and/or sublicense copies of the Software, and to permit persons to whom the Software is furnished to do so, subject to the following conditions:

The above copyright notice and this permission notice shall be included in all copies or substantial portions of the Software.

THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS OR IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY, FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT. IN NO EVENT SHALL THE AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER LIABILITY, WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING FROM, OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER DEALINGS IN THE SOFTWARE.
*/

var langcode;
var flipper;
var previousX;
var previousY;
var stretcher;
//TODO: wrap history in object, create .current function
var historyArray;
var historyCount;
var previousHistoryCount;
var replacedHistoryItem;
var historyPointer;
var cacheAge;
var userName;
var progInd;
var currentVersion;
var windowCollapsed;
var backsideRequested;
var frontsideRequested;
var tempHeight;
var keyPressed;
var wikiReq;

function loaded2() {
	flipper = new Fader(document.getElementById('flip'), null, 500);
	document.getElementById('content').innerHTML = "";
	scrollerInit(document.getElementById("myScrollBar"), document.getElementById("myScrollTrack"), document.getElementById("myScrollThumb"));
//    windowHeight = parseInt(document.defaultView.getComputedStyle(document.getElementById('front'), "").getPropertyValue("height"));

  //  stretcher = new Stretcher(document.getElementById('front'), 73, 250, stretchFinished);

	calculateAndShowThumb(document.getElementById('content'));
	if (window.widget) {
		widget.system("mkdir ~/Library/Caches/WikipediaWidget", emptyFunction);
	}
	if (window.widget) {
		setCacheAge(widget.preferenceForKey("CacheAge"));
		setLanguage(widget.preferenceForKey("langcode"));
	}
	if (typeof(cacheAge) == "undefined" || cacheAge == "undefined" || cacheAge == "") {
		setCacheAge(5);
	}
	if (typeof(langcode) == "undefined" || langcode == "undefined" || langcode == "") {
		setLanguage('en');
	}

	progInd = new ProgressIndicator(document.getElementById('progressGraphic'), "Images/prog");
	historyArray = new Array();
	historyCount = 0;
	historyPointer = 0;
	if (window.widget) {
		userName = widget.system("echo $USER", null).outputString.replace(/\n/, '');
	}
	currentVersion = getKeyValue("version.plist", "CFBundleVersion");
	windowCollapsed = true;
	backsideRequested = false;
	frontsideRequested = false;

	checkForUpdate();
	document.getElementById('versionNumber').innerHTML = currentVersion;
	if (window.widget) {
		widget.onshow = checkForUpdate;
	}
}


function openLinkInBrowser2(url) {
	if (window.widget) {
		widget.system("open '"+url+"'", null);
		widget.openURL('');
	}
}
function openInBrowser2() {
	if (document.getElementById('searchInput').value.length > 0) {
		searchTerm = document.getElementById('searchInput').value.replace(/[\s]/gi, '+');
		searchTerm = escape(searchTerm);
		wikiUrl = 'http://'+langcode+'.wikipedia.org/wiki/Special:Search?search='+searchTerm+'&go=Go';
	} else {
		wikiUrl = 'http://' + langcode + '.wikipedia.org/wiki/';
	}
	if (window.widget) {
		widget.system("open '"+wikiUrl+"'", null);
		widget.openURL('');
	}
}

function searchWiki2(search) {
	search = unescape(search);
	document.getElementById('searchInput').value = search.replace(/_/g, ' ');
	if (search.length < 1) {
		displayContent('collapse');
		document.getElementById('searchInput').value = "";
		//TODO: check for x button click
		//if (historyPointer == historyCount) {
		//    historyPointer++;
		//}
	} else {
		//TODO: if lancode is en, find/replace unicode characters
		var article = new HistoryObject(search, langcode);
		addToHistory(article);
		openArticle(article);
	}
}

function openArticle2(article) {
	document.getElementById('searchInput').value = article.name.replace(/_/g, ' ');
	if (window.widget) {
		widget.system("find ~/Library/Caches/WikipediaWidget -mmin +"+cacheAge+" -delete", null);
	}
	req = new XMLHttpRequest();
	req.open("GET", article.file, false);
	req.send(null);
	response = req.responseText;
	req = null;

	if (response == null || response.length < 200) {
		progInd.start();
		requestArticle(article);
	} else {
		if (response.indexOf('<head>') > 0) {
			processRawHTML(response);
		} else {
			processCachedHTML(response);
		}
	}

}
function requestArticle2(article) {
	if (langcode.length < 2) {
		//TODO: replace with localizable string
		output = "<p><b>Please enter a Wikipedia language code</b> in the preference panel of this widget.  These are the letters (usually 2, sometimes 3 or more) found in the Wikipedia URL for your language: htt://XX.wikipedia.org, where XX is the language code.  Here are some common codes:</p><ul><li>English - en</li><li>Deutsch - de</li><li>日本語 - ja</li><li>Français - fr</li><li>Svenska - sv</li><li>Polski - pl</li><li>Nederlands - nl</li><li>Español - es</li><li>Italiano - it</li><li>Português - pt</li><li>Simple English - simple</ul>";
		displayContent(output);
	} else {
		//    --connect-timeout 30 --max-time 30
		var l = article.lang;
		if (l=='en'||l=='sv'||l=='nl') {
			searchName = escape(article.name);
		} else {
			searchName = article.name;
		}
		searchName = searchName.replace(/&/g, "%26").replace(/_/g, '+');
		reqUrl = "http://"+article.lang+".wikipedia.org/wiki/Special:Search?search="+searchName+"&go=Go";
		if (article.lang == 'it') {
			reqUrl = encodeURI(reqUrl);
		}

		wikiReq = new XMLHttpRequest();
		wikiReq.onreadystatechange = checkRequestResponse;
		wikiReq.open("GET", reqUrl, true);
		wikiReq.setRequestHeader("Cache-Control", "no-cache");
		wikiReq.send(null);
	}
}

function checkRequestResponse2() {
	if (wikiReq.readyState == 4) {
		response = wikiReq.responseText;
		processRawHTML(response);
	}
}

function cancelArticleRequest2() {
//TODO: set onmouseover of progind to display X
	wikiReq.abort();
	progInd.stop();
	removeCurrentItemFromHistory();
	document.getElementById('searchInput').value = historyArray[historyPointer].name.replace(/_/g, ' ');

}

//This isn't currently used, and will be deleted.  Just left for comparison:
function curlArticle2(article) {
	if (langcode.length < 2) {
		//TODO: replace with localizable string
		output = "<p><b>Please enter a Wikipedia language code</b> in the preference panel of this widget.  These are the letters (usually 2, sometimes 3 or more) found in the Wikipedia URL for your language: htt://XX.wikipedia.org, where XX is the language code.  Here are some common codes:</p><ul><li>English - en</li><li>Deutsch - de</li><li>日本語 - ja</li><li>Français - fr</li><li>Svenska - sv</li><li>Polski - pl</li><li>Nederlands - nl</li><li>Español - es</li><li>Italiano - it</li><li>Português - pt</li><li>Simple English - simple</ul>";
		displayContent(output);
	} else {
		//    --connect-timeout 30 --max-time 30
		if (article.lang == 'en') {
			searchName = escape(article.name);
		} else {
			searchName = article.name;
		}
		searchName = searchName.replace(/&/g, "%26").replace(/_/g, '+');
		var curlCommand = "/usr/bin/curl -L 'http://"+article.lang+".wikipedia.org/wiki/Special:Search?search="+searchName+"&go=Go\' > "+article.file;
		if (window.widget) {
			widget.system(curlCommand, checkCurlResult);
		}
	}
}

function checkCurlResult2(result) {
	switch (result.status) {
	case 0:
		req = new XMLHttpRequest();
		req.open("GET", historyArray[historyPointer].file, false);
		req.send(null);
		response = req.responseText;
		req = null;
		processRawHTML(response);
		break;
	//case 28:
	default:
		//TODO: replace with localizable string
		ouput = "<p>There was a problem connecting to the wikipedia server.</p>";
		displayContent(output);
	}
}
function processCachedHTML2(input) {
	input = input.replace(/qzq/g, "'");
	displayContent(input);
}
function processRawHTML2(input) {
	resultsIndex = input.indexOf("<div id='results'>");
	if (resultsIndex > -1) {
		start = resultsIndex;
		if (input.indexOf("Search in namespaces:") > -1) {
			end = input.indexOf("Search in namespaces:");
		} else {
			end = input.indexOf("<!-- end content -->");
		}
	} else {
		start = input.indexOf('<h1 class="firstHeading">');
		end = input.indexOf("<!-- end content -->");
	}
	output = input.substring(start, end);

	tocPattern = /a\shref="\#/g;
	tocReplace = '';
	//"
	output = output.replace(tocPattern, tocReplace);

	wikiPattern = /href=\n*"\/wiki\/(\S+)\stitle=[^>]+/g;
	wikiReplace = 'href=\'javascript:searchWiki("$1)\'';
	output = output.replace(wikiPattern, wikiReplace);

	imgPattern = /href=\n*"\/wiki\/(\S+)/g;
	imgReplace = 'href=\'javascript:searchWiki("$1)\'';
	output = output.replace(imgPattern, imgReplace);

	editPattern = /href=\n*"\/(\S+)/g;
	editReplace = 'href=\'javascript:openLinkInBrowser("http://' + langcode + '.wikipedia.org/$1)\'';
	output = output.replace(editPattern, editReplace);

	extPattern = /href=\n*"([^\s>]+)/g;
	extReplace = 'href=\'javascript:openLinkInBrowser("$1)\'';
	output = output.replace(extPattern, extReplace);

	srcPattern = /src=\n*"\//g;
	srcReplace = 'src="http://'+langcode+'.wikipedia.org/';
	output = output.replace(srcPattern, srcReplace);

//    titlePattern = /title=([^>]+)/g;
  //  output = output.replace(titlePattern, '');

	displayContent(output);
	nameStart = input.indexOf("<h1") + 25;
	nameEnd = input.indexOf("</h1>");
	properName = input.substring(nameStart, nameEnd);
	properName = properName.replace('&amp;', '&');
	if (historyArray[historyPointer].name == "Special:Randompage") {
		document.getElementById('searchInput').value = properName;
		resetHistoryObject(properName, langcode);
		document.getElementById('randomLink').src = "Images/randomOff.png";
	}
	historyArray[historyPointer].properURL = "http://"+historyArray[historyPointer]+".wikipedia.org/wiki/"+properName.replace(/\s/g, '_');

	output = output.replace(/'/g, "qzq");
	output = output.replace(/\t/g, " ");
	output = output.replace(/\n/g, " ");
	output = '<meta http-equiv="Content-Type" content="text/html; charset=utf-8"> '+output;
	if (window.widget) {
		widget.system("echo '"+output+"' > "+historyArray[historyPointer].file, emptyFunction);
	}
}

function displayContent2(input) {
	if (input == "collapse") {
		input = "";
		if (stretcher.isStretched() == true) {
			document.getElementById('ResizeBox').style.display = "none";
			stretcher.stretch(event);
		}
	} else if (stretcher.isStretched() == false) {
		document.getElementById('ResizeBox').style.display = "block";
		stretcher.stretch(event);
	}
	progInd.stop();
	document.getElementById('content').innerHTML = input;
	calculateAndShowThumb(document.getElementById('content'));
	document.getElementById('searchInput').value = historyArray[historyPointer].name.replace(/_/g, ' ');
	calculateAndShowThumb(document.getElementById('content'));
	scrollBy(currentContentHeight);
}
function selectSearchInput2() {
//    document.getElementById('searchInput').select();
}
function setSearchValue(input) {
	document.getElementById('searchInput').value = input;
}
function stretchFinished2 () {

	if (backsideRequested == true) {
		setTimeout( function() { transitionToBack(); }, 30);
	} else if (frontsideRequested == true) {
		frontsideRequested = false;
		stretcher.maxPosition = tempHeight;
	}
	calculateAndShowThumb(document.getElementById('content'));

}

function setCacheAge2(minutes) {
	if (minutes == '') {
		minutes = 0;
	}
	cacheAge = minutes;
	if (window.widget) {
		widget.setPreferenceForKey(minutes, "CacheAge");
	}
}
function setLanguage2(language) {
	langcode = language;
	switch (langcode) {
		case "en": langname = "English"; break;
		case "fr": langname = "Français"; break;
		case "ja": langname = "日本語"; break;
		case "sv": langname = "Svenska"; break;
		case "nl": langname = "Nederlands"; break;
		case "it": langname = "Italiano"; break;
		case "de": langname = "Deutsch"; break;
		case "pl": langname = "Polski"; break;
		case "es": langname = "Español"; break;
		case "pt": langname = "Português"; break;
		case "he": langname = "עברית"; break;
		case "zh": langname = "中文"; break;
		case "bg": langname = "Български"; break;
		case "ru": langname = "Русский"; break;
		case "uk": langname = "Українська"; break;
		case "ca": langname = "Català"; break;
		case "da": langname = "Dansk"; break;
		case "no": langname = "Norsk"; break;
		case "ro": langname = "Română"; break;
		case "sr": langname = "Српски"; break;
		case "sl": langname = "Slovenščina"; break;
		case "fi": langname = "Suomi"; break;
		case "mt": langname = "Malti"; break;
		case "ko": langname = "한국어"; break;
		case "sa": langname = "संस्कृतम्"; break;
		case "fa": langname = "فارسی"; break;
		case "ar": langname = "العربية"; break;
		case "el": langname = "Ελληνικά"; break;
		case "hi": langname = "हिन्दी"; break;
		case "af": langname = "Afrikaans"; break;
		case "ast": langname = "Asturianu"; break;
		case "be": langname = "Беларуская"; break;
		case "bs": langname = "Bosanski"; break;
		case "cs": langname = "Česká"; break;
		case "cy": langname = "Cymraeg"; break;
		case "et": langname = "Eesti"; break;
		case "simple": langname = "Simple English"; break;
		case "eu": langname = "Euskara"; break;
		case "fy": langname = "Frysk"; break;
		case "gd": langname = "Gàidhlig"; break;
		case "gl": langname = "Galego"; break;
		case "hr": langname = "Hrvatski"; break;
		case "io": langname = "Ido"; break;
		case "id": langname = "Bahasa Indonesia"; break;
		case "ia": langname = "Interlingua"; break;
		case "is": langname = "Íslenska"; break;
		case "ku": langname = "Kurdî / كوردی"; break;
		case "la": langname = "Latina"; break;
		case "lv": langname = "Latviešu"; break;
		case "lb": langname = "Lëtzebuergesch"; break;
		case "lt": langname = "Lietuvių"; break;
		case "hu": langname = "Magyar"; break;
		case "ms": langname = "Bahasa Melayu"; break;
		case "nn": langname = "Norsk (nynorsk)"; break;
		case "nds": langname = "Plattdüütsch"; break;
		case "sk": langname = "Slovenčina"; break;
		case "tt": langname = "Tatarça"; break;
		case "tr": langname = "Türkçe"; break;
		case "th": langname = "ไทย"; break;
		case "wa": langname = "Walon"; break;
		default:   langname = langcode;
	}
	document.getElementById('searchInput').setAttribute('placeholder', langname);
	if (window.widget) {
		widget.setPreferenceForKey(langcode, "langcode");
	}
}
function getKeyValue(plist, key) {
   var key_value = null;
   var xml_http = new XMLHttpRequest();
   xml_http.open("GET", plist, false);
   xml_http.send(null);

   var xml = xml_http.responseXML;
   if (xml) {
	   var keys = xml.getElementsByTagName("key");
	   var vals = xml.getElementsByTagName("string");

	   for (var i=0; i < keys.length; i++) {
	      if (keys[i].firstChild.data == key) {
	         key_value = vals[i].firstChild.data;
	         break;
	      }
	   }
   }
   return key_value;
}

function checkForUpdate2() {
	req = new XMLHttpRequest();
	req.onreadystatechange = compareVersion;
	req.open("GET", "http://www.whatsinthehouse.com/widgets/wikiVersion.php", true);
	req.setRequestHeader("Cache-Control", "no-cache");
	req.send(null);
}
function compareVersion2() {
	if (req.status == 200) {
		var serverVersion = req.responseText;

		if ((currentVersion != serverVersion) && (serverVersion != null) && (serverVersion != "")) {
			document.getElementById('updateMessage').style.display='block';
		} else {
			document.getElementById('updateMessage').style.display='none';
		}
	}
}
function showBackside2(event) {
	if (stretcher.isStretched() == true) {
		transitionToBack();
	} else {
		backsideRequested = true;
		tempHeight = stretcher.maxPosition;
		stretcher.maxPosition = 215;
		stretcher.stretch(event);
	}
}
function transitionToBack2() {
	//340x225
	if (window.widget) {
		window.widget.prepareForTransition("ToBack");
	}
	document.getElementById('fliprollie').style.display='none';
	document.getElementById('front').style.display='none';
	document.getElementById('parentDiv').style.display='none';
	document.getElementById('searchInput').style.display='none';
	document.getElementById('wikiLink').style.display='none';
	document.getElementById('randomLink').style.display='none';
	document.getElementById('back').style.display='block';

	document.getElementById('doneButton').src = "Images/done.png";

	document.getElementById('languageField').value = langcode;
	document.getElementById('cacheField').value = cacheAge;

	if (window.widget) {
		setTimeout("window.widget.performTransition()", 0);
	}
}

function showFront2(event) {
	if (window.widget) {
		window.widget.prepareForTransition("ToFront");
	}
	document.getElementById('back').style.display='none';

	document.getElementById('front').style.display='block';
	document.getElementById('parentDiv').style.display='block';
	document.getElementById('wikiLink').style.display='block';
	document.getElementById('randomLink').style.display='block';
	document.getElementById('searchInput').style.display='block';
	setLanguage(document.getElementById('languageField').value);
	setCacheAge(document.getElementById('cacheField').value);

	if (window.widget) {
		setTimeout("window.widget.performTransition()", 0);
	}
	if (backsideRequested == true) {
		backsideRequested = false;
		frontsideRequested = true;
		setTimeout( function() { stretcher.stretch(event); }, 800);
	}
}

function emptyFunction2(input) {
	return;
}

function emptyCache2() {
	if (window.widget) {
		widget.system("find ~/Library/Caches/WikipediaWidget -mmin +0 -delete", null);
	}
}
function mouseWheelMove2(event) {
	var clicks = window.event.wheelDelta/20;
	scrollBy(clicks);
}
/******** Progress Indicator *********/

function ProgressIndicator(element, imageBaseURL) {
	this.count = 0;
	this.timer = null;
	this.element = element;
	this.element.style.display = "none";
	this.imageBaseURL = imageBaseURL;
}

ProgressIndicator.prototype = {
	start : function () {
		this.element.style.display = "block";
		if (this.timer) clearInterval(this.timer);
		this.tick();
		var localThis = this;
		this.timer = setInterval (function() { localThis.tick() }, 60);
	},

	stop : function () {
		clearInterval(this.timer);
		this.element.style.display = "none";
	},

	tick : function () {
		var imageURL = this.imageBaseURL + (this.count + 1) + ".png";
		this.element.src = imageURL;
		this.count = (this.count + 1) % 12;
	}
}
/*
function ProgressIndicator2() {
	this.count = 1;
	this.timer = null;
}
ProgressIndicator.prototype.start = function () {
	this.image = 'Images/prog1.png';
	document.getElementById('progressGraphic').style.display = "block";
	if (this.timer) {
		clearInterval(this.timer);
	}
	var localThis = this;
	this.tick();
	this.timer = setInterval (function() { localThis.tick(); }, 60);
}
ProgressIndicator.prototype.stop = function () {
	clearInterval(this.timer);
	document.getElementById('progressGraphic').style.display = "none";
}
ProgressIndicator.prototype.tick = function () {
	document.getElementById('progressGraphic').src = this.image;

	if (this.count < 12) {
		this.count++;
		this.image = "Images/prog"+this.count+".png";
	} else {
		this.count = 1;
		this.image = "Images/prog"+this.count+".png";
	}
}*/
/******** History stuff *********/

function HistoryObject(name, type) {
   // name = name.replace(/\s/g, '_');
	this.name = name;
	this.type = type;
	nameForFile = name.replace(/[:]/g, '-').replace(/[(]/g, "lp").replace(/[)]/g, "rp").replace(/'/g, 'qt').replace(/&/g, 'amp');
	var fileName = "/Users/"+userName+"/Library/Caches/AnswersWidget/"+"_"+nameForFile+".html";
	this.file = fileName;
	this.properURL = "http://www.answers.com/";
}
function addToHistory(item) {
		historyPointer++;
		replacedHistoryItem = historyArray[historyPointer];
		historyArray[historyPointer] = item;
		/*  This screws up cancelArticleRequest
		for (i = historyPointer+1; i < historyCount; i++) {
			historyArray[i] = null;
		}*/
		previousHistoryCount = historyCount;
		historyCount = historyPointer;
		disableForwardButton();
		if (historyPointer > 1) {
			enableBackButton();
		}
}
function removeCurrentItemFromHistory() {
		historyArray[historyPointer] = replacedHistoryItem;

		historyCount = previousHistoryCount;
		historyPointer--;
		if (historyPointer < historyCount) {
			enableForwardButton();
		}
		if (historyPointer == 1) {
			disableBackButton();
		}

}

function resetHistoryObject(name) {
	historyArray[historyPointer] = new HistoryObject(name);
}
function copyProperURL() {
	if (window.widget) {
		//todo: escape proper name, rather than encoding url
		var copyCommand = "/usr/bin/osascript -e 'set the clipboard to \""+encodeURI(historyArray[historyPointer].properURL)+"\" as string'";
		widget.system(copyCommand, null);
	}
}
function goBackInHistory() {
	if (historyPointer > 1) {
		historyPointer--;
		//openArticle(historyArray[historyPointer]);
		processQuery(historyArray[historyPointer].name, historyArray[historyPointer].type, true);
		setSearchValue(historyArray[historyPointer].name);
		enableForwardButton();
		if (historyPointer == 1) {
			disableBackButton();
		}
	}
}
function goForwardInHistory() {
	if (historyPointer < historyCount) {
		historyPointer++;
//        openArticle(historyArray[historyPointer]);
		processQuery(historyArray[historyPointer].name, historyArray[historyPointer].type, true);
		setSearchValue(historyArray[historyPointer].name);
		enableBackButton();
		if (historyPointer == historyCount) {
			disableForwardButton();
		}
	}
}

function enableBackButton() {
	document.getElementById('backButton').src = "Images/backButtonOn.png";
}
function disableBackButton() {
	document.getElementById('backButton').src = "Images/backButtonOff.png";
}
function enableForwardButton() {
	document.getElementById('forwardButton').src = "Images/forwardButtonOn.png";
}
function disableForwardButton() {
	document.getElementById('forwardButton').src = "Images/forwardButtonOff.png";
}

/******** Window resizing *********/

var lastPos;
function mouseDown2(event)
{
	var x = event.x + window.screenX;
	var y = event.y + window.screenY;

	document.addEventListener("mousemove", mouseMove, true);
	document.addEventListener("mouseup", mouseUp, true);
	lastPos = {x:x, y:y};
	event.stopPropagation();
	event.preventDefault();
}

function mouseMove2(event)
{
	var screenX = event.x + window.screenX;
	var screenY = event.y + window.screenY;

	var deltaX = 0;
	var deltaY = 0;

	if ( (window.innerWidth + (screenX - lastPos.x)) >= 367 ) {
		deltaX = screenX - lastPos.x;
		lastPos.x = screenX;
	}
	if ( (window.innerHeight + (screenY - lastPos.y)) >= 215 ) {
		deltaY = screenY - lastPos.y;
		lastPos.y = screenY;
	}
	document.getElementById('front').style.width = parseInt(document.getElementById('front').style.width) + deltaX;
	document.getElementById('front').style.height = parseInt(document.getElementById('front').style.height) + deltaY;
	window.resizeBy(deltaX, deltaY);
	calculateAndShowThumb(document.getElementById('content'));
	event.stopPropagation();
	event.preventDefault();
}
function mouseUp2(event)
{
	window.resizeTo(parseInt(document.getElementById('front').style.width), parseInt(document.getElementById('front').style.height));
	document.removeEventListener("mousemove", mouseMove, true);
	document.removeEventListener("mouseup", mouseUp, true);
	event.stopPropagation();
	event.preventDefault();
}

